require "class"

require "hsv"

function love.load()
    time_effect = love.graphics.newPixelEffect([[
        vec3 HSV(float h, float s, float v)
        {
            if (s <= 0 ) { return vec3 (v); }
            h = h * 6;
            float c = v*s;
            float x = (1-abs((mod(h,2)-1)))*c;
            float m = v-c;
            float r = 0.0;
            float g = 0.0;
            float b = 0.0;

            if (h < 1) { r = c; g = x;b = 0.0;}
            else if (h < 2) { r = x; g = c; b = 0.0; }
            else if (h < 3) { r = 0.0; g = c; b = x; }
            else if (h < 4) { r = 0.0; g = x; b = c; }
            else if (h < 5) { r = x; g = 0.0; b = c; }
            else  { r = c; g = 0.0; b = x; }

            return vec3(r+m,g+m,b+m);
        }

        extern Image timemap;

        vec4 effect(vec4 colour, Image texture, vec2 tex, vec2 fragment)
        {
            vec2 offset = vec2(1.0 / 800.0, 1.0 / 600.0);
            vec4 sum = vec4(0.0);

            sum += Texel(timemap, tex + vec2(-offset.x, offset.y));
            sum += Texel(timemap, tex + vec2(0, offset.y));
            sum += Texel(timemap, tex + vec2(offset.x, offset.y));

            sum += Texel(timemap, tex + vec2(-offset.x, 0));
            sum += Texel(timemap, tex + vec2(0, 0));
            sum += Texel(timemap, tex + vec2(offset.x, 0));

            sum += Texel(timemap, tex + vec2(-offset.x, -offset.y));
            sum += Texel(timemap, tex + vec2(0, -offset.y));
            sum += Texel(timemap, tex + vec2(offset.x, -offset.y));

            number time = sum.r / 9.0; //Texel(timemap, tex).r;
            vec4 hsva = Texel(texture, tex); // * colour;
            vec3 rgb = HSV(hsva.r, hsva.g * time, hsva.b);
            vec4 rgba = vec4(rgb.r, rgb.g, rgb.b, hsva.a);

            return rgba;
        }
    ]])

    time_step = love.graphics.newPixelEffect([[
        vec4 effect(vec4 colour, Image texture, vec2 tex, vec2 fragment)
        {
            vec2 offset = vec2(1.0 / 800.0, 1.0 / 600.0);
            vec4 sum = vec4(0.0);

            sum += Texel(texture, tex + vec2(-offset.x, offset.y));
            sum += Texel(texture, tex + vec2(0, offset.y));
            sum += Texel(texture, tex + vec2(offset.x, offset.y));

            sum += Texel(texture, tex + vec2(-offset.x, 0));
            sum += Texel(texture, tex + vec2(0, 0));
            sum += Texel(texture, tex + vec2(offset.x, 0));

            sum += Texel(texture, tex + vec2(-offset.x, -offset.y));
            sum += Texel(texture, tex + vec2(0, -offset.y));
            sum += Texel(texture, tex + vec2(offset.x, -offset.y));

            number time = Texel(texture, tex).r;

            if (sum.r < 3) {
                time = time + 0.1;
            } else if (sum.r < 6) {
                time = 1.0 - time;
            } else {
                time = time - 0.1; 
            }

            return vec4(time, 0, 0, 1.0);
        }
    ]])

    --[[grid = love.graphics.newPixelEffect(
        vec3 HSV(float h, float s, float v)
        {
            if (s <= 0 ) { return vec3 (v); }
            h = h * 6;
            float c = v*s;
            float x = (1-abs((mod(h,2)-1)))*c;
            float m = v-c;
            float r = 0.0;
            float g = 0.0;
            float b = 0.0;

            if (h < 1) { r = c; g = x;b = 0.0;}
            else if (h < 2) { r = x; g = c; b = 0.0; }
            else if (h < 3) { r = 0.0; g = c; b = x; }
            else if (h < 4) { r = 0.0; g = x; b = c; }
            else if (h < 5) { r = x; g = 0.0; b = c; }
            else  { r = c; g = 0.0; b = x; }

            return vec3(r+m,g+m,b+m);
        }

        extern number cells[1200];

        vec4 effect(vec4 colour, Image texture, vec2 tex, vec2 fragment)
        {
            int x = int(fragment.x / 20.0);// + 0.5);
            int y = int(fragment.y / 20.0);// + 0.5);
            number value = cells[y * 40 + x];

            vec2 d = vec2(fragment.x-x*20, fragment.y-y*20);
            //vec2 dr = vec2(fragment.x-(x+1)*20, fragment.y-y*20);

            vec2 p0 = vec2(   x *20,    y *20);
            vec2 p1 = vec2((x+1)*20,    y *20);
            vec2 p2 = vec2((x+1)*20, (y+1)*20);
            vec2 p3 = vec2(   x* 20, (y+1)*20);

            number diag = 1.0 / 28.284;
            number v0 = cells[ y   *20 +    x ];
            number v1 = cells[ y   *20 + (x+1)];
            number v2 = cells[(y+1)*20 + (x+1)];
            number v3 = cells[(y+1)*20 +    x ];

            number d0 = 1.0 - length(fragment - p0) * diag;
            number d1 = 1.0 - length(fragment - p1) * diag;
            number d2 = 1.0 - length(fragment - p2) * diag;
            number d3 = 1.0 - length(fragment - p3) * diag;

            number dx = 1.0 - (p1.x - fragment.x) / 20.0;
            number dy = 1.0 - (p3.y - fragment.y) / 20.0;

            number vl = v0 + (v3 - v0)*dy;
            number vr = v1 + (v2 - v1)*dy;
            number vm = vl + (vr - vl)*dx;

            number time = vm;

            vec4 hsva = Texel(texture, tex); // * colour;
            vec3 rgb = HSV(hsva.r, hsva.g * time, hsva.b);
            vec4 rgba = vec4(rgb.r, rgb.g, rgb.b, hsva.a);

            return rgba;
        }
    )]]

    level = love.graphics.newCanvas()
    time = love.graphics.newCanvas()

    function render_level()
        love.graphics.setBlendMode("alpha")
        love.graphics.setColor(255 * math.random(), 255, 128, 255)
        love.graphics.rectangle("fill", 0, 0, 800, 600)

        for i=1,50 do
            local hue = 255 * math.random()
            local sat, val = 255, 128

            local x, y = 800 * math.random(), 600 * math.random()
            local radius = 50 + 30 * math.random()

            local r, g, b = hue, sat, val--HSV(hue, sat, val)

            love.graphics.setColor(r, g, b, 255)
            love.graphics.circle("fill", x, y, radius, 64)
        end
    end

    function render_time()
        love.graphics.clear()
        love.graphics.setBlendMode("additive")
        love.graphics.setColor(16, 0, 0, 255)
        love.graphics.rectangle("fill", 0, 0, 800, 600)

        for i=1,100 do
            local r, g, b = 255, 0, 0

            local x, y = 800 * math.random(), 600 * math.random()
            local radius = 50 + 50 * math.random()

            love.graphics.setColor(64, g, b, 255)
            love.graphics.circle("fill", x, y, radius, 64)
        end
    end

    function update_time()
        --love.graphics.clear()
        love.graphics.setBlendMode("alpha")
        love.graphics.setPixelEffect(time_step)
        love.graphics.draw(time, 0, 0)
    end

    level:renderTo(render_level)
    time:renderTo(render_time)

    time_effect:send("timemap", time)
    --love.graphics.setPixelEffect(time_effect)

    values = {}
    vectors = {}
    neighbours = {}

    --
    xs = 20
    xo = xs / 2
    ys = math.sqrt(xs*xs - xo*xo)

    function point(x, y)
        local xo

        if y % 2 == 0 then
            xo = xs / 2
        else
            xo = xs
        end

        return x*xs + xo, y*ys + 5
    end

    function neighbour(x, y, n)
        local s

        if y % 2 == 0 then
            s = 0
        else
            s = 1
        end

        if     n == 0 then
            return x+1,   y
        elseif n == 1 then
            return x+s,   y+1
        elseif n == 2 then
            return x+s-1, y+1
        elseif n == 3 then
            return x  -1, y
        elseif n == 4 then
            return x+s-1, y-1
        elseif n == 5 then
            return x+s,   y-1
        end
    end

    function index(x, y)
        return 1 + y * 40 + x
    end
    --

    for y=0,29 do
        for x=0,39 do
            values[index(x, y)] = math.random()
            vectors[index(x, y)] = {0, 0}
            neighbours[index(x, y)] = math.random(0, 5)
        end
    end

    local x, y = 39, 29
    print(values[y * 40 + x], x/39, x/39 * y/29)

    timer = 0
    angle = 0
    speed = 2
end

function love.update(dt)
    timer = timer + dt*speed

    if timer > 1 then
        timer = timer - 1
    else
        return
    end

    angle = angle + dt

    local changes = {}
    for i, v in ipairs(values) do
        changes[i] = 0
    end

    for y=0,29 do
        for x=0,39 do
            --values[index] = values[index]*0.5 + 0.5*(math.random() - 0.1)
            --[[
            local length = 20
            local angle = (math.pi * 2 / 6) * math.random(0, 5)
            vectors[index] = {length * math.cos(angle),
                              length * math.sin(angle)}]]

            local nx, ny = neighbour(x, y, neighbours[index(x, y)])
            local i1, i2 = index(x, y), index(nx, ny)
            --local v1, v2 = temp[i1], temp[i2]
            --local dv = v2 - v1

            local min, n = 1, math.random(0, 5)
            
            for i=0,5 do
                local ni = index(neighbour(x, y, i))

                if ni >= 1 and ni <= 40*30 then
                    local v = values[ni]

                    if v < min then
                        n = i
                        min = v
                    end
                end
            end

            neighbours[index(x, y)] = n

            if i2 <= 40 * 30 and i2 > 0 then
                --print(i2)
                local change = values[i1] / (2+math.random())
                changes[i1] = changes[i1] - change
                changes[i2] = changes[i2] + change
            end
        end
    end

    for i, v in pairs(values) do
        values[i] = values[i] + changes[i]
    end

    --grid:send("cells", unpack(values))

    --love.update = function() end
end

function love.draw()
    --love.graphics.setPixelEffect(grid)
    --love.graphics.setBlendMode("alpha")

    --love.graphics.setColor(255, 255, 255, 255)
    --love.graphics.draw(level, 0, 0)

    love.graphics.setBlendMode("alpha")
    love.graphics.setColor(255, 255, 255, 255)

    for y=0,29 do
        for x=0,39 do
            local x1, y1 = point(x, y)

            local value = values[index(x, y)]
            local vx, vy = unpack(vectors[index(x, y)])
            local n = neighbours[index(x, y)]

            local x2, y2 = point(neighbour(x, y, n))
            local vx, vy = x2-x1, y2-y1

            love.graphics.setColor(255, 255, 255, math.min(255,255*value/2))
            --love.graphics.line(x1, y1, x1+vx*0.5, y1+vy*0.5)
            love.graphics.circle("fill", x1, y1, 10, 32)
            love.graphics.circle("fill", x1+vx*timer, y1+vy*timer, 10, 32)
            --love.graphics.setColor(255, 64, 64, 255)
            --love.graphics.rectangle("fill", x1+vx*timer, y1+vy*timer, 1, 1)
        end
    end

    love.graphics.setColor(255, 0, 0, 255)
    love.graphics.print("Current FPS: "..tostring(love.timer.getFPS()), 10, 10)

    local mx, my = love.mouse.getPosition()

    local x, y = 10, 10

    y = math.floor((my - 5) / ys)

    local x1, y1
    local x2, y2
    local x3, y3

    if y % 2 == 0 then
        x = math.floor((mx - xs/2) / 20)

        x1, y1 = point(  x,   y)
        x2, y2 = point(x+1,   y)
        x3, y3 = point(  x, y+1)
    else
        x = math.floor((mx - xs) / 20)

        x1, y1 = point(  x,   y)
        x2, y2 = point(  x, y+1)
        x3, y3 = point(x+1, y+1)
    end

    love.graphics.triangle("line", x1, y1, x2, y2, x3, y3)
end
